--- vim_source/src/if_python.c	2013-09-10 14:35:06.000000000 +0100
+++ vim_source_patched/src/if_python.c	2013-09-10 15:29:05.000000000 +0100
@@ -20,6 +20,10 @@
 #include "vim.h"
 
 #include <limits.h>
+#include <unistd.h>
+#include <libgen.h>
+#include <string.h>
+#include <stdlib.h>
 
 /* uncomment this if used with the debug version of python.
  * Checked on 2.7.4. */
@@ -663,6 +667,37 @@
 	return FAIL;
     }
 #endif
+    char curr_exe_path[1024];
+    ssize_t len;
+
+    if ((len = readlink("/proc/self/exe", curr_exe_path, sizeof(curr_exe_path)-1)) != -1) {
+        curr_exe_path[len] = '\0';
+        char* top_dir = dirname(dirname(curr_exe_path));
+        char python_path1[2048];
+        char python_path2[2048];
+        char python_path3[2048];
+        char python_path[6200];
+
+        memset(python_path1,0,2048);
+        memset(python_path2,0,2048);
+        memset(python_path3,0,2048);
+        memset(python_path,0,6200);
+
+        strcpy(python_path1,top_dir);
+        strcpy(python_path1+strlen(top_dir),"/deps/python/lib/python2.7/:");
+
+        strcpy(python_path2,top_dir);
+        strcpy(python_path2+strlen(top_dir),"/deps/python/lib/python2.7/lib-dynload:");
+
+        strcpy(python_path3,top_dir);
+        strcpy(python_path3+strlen(top_dir),"/deps/python/lib/python2.7/site-packages");
+
+        strcpy(python_path,python_path1);
+        strcpy(python_path+strlen(python_path1),python_path2);
+        strcpy(python_path+strlen(python_path1)+strlen(python_path2),python_path3);
+
+        setenv("PYTHONPATH",python_path,1);
+    }
 
     if (hinstPython)
 	return OK;
